#include <stdio.h>
#include <jni.h>
#include <monetra.h>
#include <stdlib.h>
#include "com_mainstreetsoftworks_MONETRA.h"

int initialized=0;


void init_locks(JNIEnv *env, jobject thisObj)
{
  // pthread_mutex_init(&sess_lock, NULL);
}

void destroy_locks(JNIEnv *env, jobject thisObj)
{
  //pthread_mutex_destroy(&sess_lock);
}

void lock_it(JNIEnv *env, jobject thisObj)
{
  //(*env)->MonitorEnter(env, (jobject)lock);
  //pthread_mutex_lock(&sess_lock);
}

void unlock_it(JNIEnv *env, jobject thisObj)
{
  //(*env)->MonitorExit(env, (jobject)lock);
  //pthread_mutex_unlock(&sess_lock);
}


char *Java_to_CString(JNIEnv *env, jstring val)
{
  if (val == NULL) return(NULL);
  return((char *)(*env)->GetStringUTFChars(env, val, 0));
}

void Free_CString(JNIEnv *env, jstring val, char *cstring)
{
  if (val == NULL || cstring == NULL) return;
  (*env)->ReleaseStringUTFChars(env, val, cstring);
}

jstring CString_to_Java(JNIEnv *env, char *cstring)
{
  if (cstring == NULL) return(NULL);
  return((*env)->NewStringUTF(env, cstring));
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1InitConn(JNIEnv *env, jobject thisObj, jstring cafile)
{
  char *ca=NULL;
  MCVE_CONN *myconn;
  
  if (!initialized) {
    initialized=1;
    ca=Java_to_CString(env, cafile);
    MCVE_InitEngine(ca);
    Free_CString(env, cafile, ca);
  }
  myconn=(MCVE_CONN *)malloc(1*sizeof(MCVE_CONN));
  MCVE_InitConn(myconn);

  return((jint)myconn);
}

JNIEXPORT void JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1DestroyConn(JNIEnv *env, jobject thisObj, jint conn)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  MCVE_DestroyConn(myconn);
  free(myconn);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1CheckStatus(JNIEnv *env, jobject thisObj, jint conn, jint identifier)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_CheckStatus(myconn, identifier);
  unlock_it(env, thisObj);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1Connect(JNIEnv *env, jobject thisObj, jint conn)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_Connect(myconn);
  unlock_it(env, thisObj);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1SetTimeout(JNIEnv *env, jobject thisObj, jint conn, jint secs)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_SetTimeout(myconn, secs);
  unlock_it(env, thisObj);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1SetBlocking(JNIEnv *env, jobject thisObj, jint conn, jint tf)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_SetBlocking(myconn, tf);
  unlock_it(env, thisObj);
  return(ret);
}


JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1TransNew(JNIEnv *env, jobject thisObj, jint conn)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_TransNew(myconn);
  unlock_it(env, thisObj);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1TransParam(JNIEnv *env, jobject thisObj, jint conn, jint identifier, jint key, jstring value)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *myvalue;
  myvalue=Java_to_CString(env, value);
  lock_it(env, thisObj);

  switch (key) {

    /* Int Values */
    case MC_TRANTYPE:
    case MC_ADMIN:
    case MC_AUDITTYPE:
    case MC_EXCHARGES:
    case MC_INQUIRY:
    case MC_PRIORITY:
    case MC_CARDTYPES:
    case MC_SUB:
    case MC_ORIGTYPE:
    case MC_VOIDORIGTYPE:
    case MC_USER_SUB:
    case MC_USER_MODE:
      ret=MCVE_TransParam(myconn, identifier, key, atoi(myvalue));
    break;

    /* Long Values */
    case MC_PTRANNUM:
    case MC_TIMESTAMP:
    case MC_MARKER:
      ret=MCVE_TransParam(myconn, identifier, key, atol(myvalue));
    break;

    /* MCVE_int64 values */
    case MC_TTID:
      ret=MCVE_TransParam(myconn, identifier, key, (MCVE_int64)atoll(myvalue));
    break;

    /* Double Values */
    case MC_AMOUNT:
    case MC_EXAMOUNT:
    case MC_RATE:
      ret=MCVE_TransParam(myconn, identifier, key, atof(myvalue));
    break;

    /* String Values */
    default:
      ret=MCVE_TransParam(myconn, identifier, key, myvalue);
    break;
  }
  unlock_it(env, thisObj);
  Free_CString(env, value, myvalue);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1CustomTransParam(JNIEnv *env, jobject thisObj, jint conn, jint identifier, jstring key, jstring value)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *myvalue, *mykey;
  myvalue=Java_to_CString(env, value);
  mykey=Java_to_CString(env, key);
  lock_it(env, thisObj);
  ret=MCVE_TransParam(myconn, identifier, MC_CUSTOM, mykey, myvalue);
  unlock_it(env, thisObj);
  Free_CString(env, value, myvalue);
  Free_CString(env, key, mykey);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1TransSend(JNIEnv *env, jobject thisObj, jint conn, jint identifier)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_TransSend(myconn, identifier);
  unlock_it(env, thisObj);
  return(ret);
}

JNIEXPORT jstring JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1ResponseParam(JNIEnv *env, jobject thisObj, jint conn, jint identifier, jstring key)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  char *value, *mykey;
  mykey=Java_to_CString(env, key);
  lock_it(env, thisObj);
  value=MCVE_ResponseParam(myconn, identifier, mykey);
  unlock_it(env, thisObj);
  Free_CString(env, key, mykey);
  return CString_to_Java(env, value);
}


JNIEXPORT void JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1DeleteResponse(JNIEnv *env, jobject thisObj, jint conn, jint identifier)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  lock_it(env, thisObj);
  MCVE_DeleteResponse(myconn, identifier);
  unlock_it(env, thisObj);
}


JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1Force(JNIEnv *env, jobject thisObj, jint conn, jstring musername, jstring mpassword, jstring mtrackdata, jstring maccount,
          jstring mexpdate, jdouble amount, jstring mauthcode, jstring mcomments, jstring mclerkid, jstring mstationid, jint ptrannum)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *username, *password, *trackdata, *account, *expdate, *authcode, *comments, *clerkid, *stationid;
  username=Java_to_CString(env, musername);
  password=Java_to_CString(env, mpassword);
  trackdata=Java_to_CString(env, mtrackdata);
  account=Java_to_CString(env, maccount);
  expdate=Java_to_CString(env, mexpdate);
  authcode=Java_to_CString(env, mauthcode);
  comments=Java_to_CString(env, mcomments);
  clerkid=Java_to_CString(env, mclerkid);
  stationid=Java_to_CString(env, mstationid);
  lock_it(env, thisObj);
  ret=MCVE_Force(myconn, username, password, trackdata, account, expdate, amount, authcode, comments, clerkid, stationid, ptrannum);
  unlock_it(env, thisObj);
  Free_CString(env, musername, username);
  Free_CString(env, mpassword, password);
  Free_CString(env, mtrackdata, trackdata);
  Free_CString(env, maccount, account);
  Free_CString(env, mexpdate, expdate);
  Free_CString(env, mauthcode, authcode);
  Free_CString(env, mcomments, comments);
  Free_CString(env, mclerkid, clerkid);
  Free_CString(env, mstationid, stationid);
  return(ret);
}


JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1Monitor(JNIEnv *env, jobject thisObj, jint conn)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_Monitor(myconn);
  unlock_it(env, thisObj);
  return(ret);
}
JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1Override(JNIEnv *env, jobject thisObj, jint conn, jstring musername, jstring mpassword, jstring mtrackdata,
               jstring maccount, jstring mexpdate, jdouble amount, jstring mstreet, jstring mzip, jstring mcv, jstring mcomments, jstring mclerkid, jstring mstationid, jint ptrannum)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *username, *password, *trackdata, *account, *expdate, *street, *zip, *cv, *comments, *clerkid, *stationid;
  username=Java_to_CString(env, musername);
  password=Java_to_CString(env, mpassword);
  trackdata=Java_to_CString(env, mtrackdata);
  account=Java_to_CString(env, maccount);
  expdate=Java_to_CString(env, mexpdate);
  street=Java_to_CString(env, mstreet);
  zip=Java_to_CString(env, mzip);
  cv=Java_to_CString(env, mcv);
  comments=Java_to_CString(env, mcomments);
  clerkid=Java_to_CString(env, mclerkid);
  stationid=Java_to_CString(env, mstationid);
  lock_it(env, thisObj);
  ret=MCVE_Override(myconn, username, password, trackdata, account, expdate, amount, street, zip, cv, comments, clerkid, stationid, ptrannum);
  unlock_it(env, thisObj);
  Free_CString(env, musername, username);
  Free_CString(env, mpassword, password);
  Free_CString(env, mtrackdata, trackdata);
  Free_CString(env, maccount, account);
  Free_CString(env, mexpdate, expdate);
  Free_CString(env, mstreet, street);
  Free_CString(env, mzip, zip);
  Free_CString(env, mcv, cv);
  Free_CString(env, mcomments, comments);
  Free_CString(env, mclerkid, clerkid);
  Free_CString(env, mstationid, stationid);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1PreAuth(JNIEnv *env, jobject thisObj, jint conn, jstring musername, jstring mpassword, jstring mtrackdata,
               jstring maccount, jstring mexpdate, jdouble amount, jstring mstreet, jstring mzip, jstring mcv, jstring mcomments, jstring mclerkid, jstring mstationid, jint ptrannum)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *username, *password, *trackdata, *account, *expdate, *street, *zip, *cv, *comments, *clerkid, *stationid;
  username=Java_to_CString(env, musername);
  password=Java_to_CString(env, mpassword);
  trackdata=Java_to_CString(env, mtrackdata);
  account=Java_to_CString(env, maccount);
  expdate=Java_to_CString(env, mexpdate);
  street=Java_to_CString(env, mstreet);
  zip=Java_to_CString(env, mzip);
  cv=Java_to_CString(env, mcv);
  comments=Java_to_CString(env, mcomments);
  clerkid=Java_to_CString(env, mclerkid);
  stationid=Java_to_CString(env, mstationid);
  lock_it(env, thisObj);
  ret=MCVE_PreAuth(myconn, username, password, trackdata, account, expdate, amount, street, zip, cv, comments, clerkid, stationid, ptrannum);
  unlock_it(env, thisObj);
  Free_CString(env, musername, username);
  Free_CString(env, mpassword, password);
  Free_CString(env, mtrackdata, trackdata);
  Free_CString(env, maccount, account);
  Free_CString(env, mexpdate, expdate);
  Free_CString(env, mstreet, street);
  Free_CString(env, mzip, zip);
  Free_CString(env, mcv, cv);
  Free_CString(env, mcomments, comments);
  Free_CString(env, mclerkid, clerkid);
  Free_CString(env, mstationid, stationid);
  return(ret);
}


JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1PreAuthCompletion(JNIEnv *env, jobject thisObj, jint conn, jstring musername, jstring mpassword, jdouble finalamount, jint sid, jint ptrannum)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *username, *password;
  username=Java_to_CString(env, musername);
  password=Java_to_CString(env, mpassword);
  lock_it(env, thisObj);
  ret=MCVE_PreAuthCompletion(myconn, username, password, finalamount, sid, ptrannum);
  unlock_it(env, thisObj);
  Free_CString(env, musername, username);
  Free_CString(env, mpassword, password);
  return(ret);
}


JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1Return(JNIEnv *env, jobject thisObj, jint conn, jstring musername, jstring mpassword, jstring mtrackdata,
               jstring maccount, jstring mexpdate, jdouble amount, jstring mcomments, jstring mclerkid, jstring mstationid, jint ptrannum)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *username, *password, *trackdata, *account, *expdate, *comments, *clerkid, *stationid;
  username=Java_to_CString(env, musername);
  password=Java_to_CString(env, mpassword);
  trackdata=Java_to_CString(env, mtrackdata);
  account=Java_to_CString(env, maccount);
  expdate=Java_to_CString(env, mexpdate);
  comments=Java_to_CString(env, mcomments);
  clerkid=Java_to_CString(env, mclerkid);
  stationid=Java_to_CString(env, mstationid);
  lock_it(env, thisObj);
  ret=MCVE_Return(myconn, username, password, trackdata, account, expdate, amount, comments, clerkid, stationid, ptrannum);
  unlock_it(env, thisObj);
  Free_CString(env, musername, username);
  Free_CString(env, mpassword, password);
  Free_CString(env, mtrackdata, trackdata);
  Free_CString(env, maccount, account);
  Free_CString(env, mexpdate, expdate);
  Free_CString(env, mcomments, comments);
  Free_CString(env, mclerkid, clerkid);
  Free_CString(env, mstationid, stationid);
  return(ret);
}


JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1ReturnCode(JNIEnv *env, jobject thisObj, jint conn, jint identifier)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_ReturnCode(myconn, identifier);
  unlock_it(env, thisObj);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1ReturnStatus(JNIEnv *env, jobject thisObj, jint conn, jint identifier)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_ReturnStatus(myconn, identifier);
  unlock_it(env, thisObj);
  return(ret);
}



JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1Sale(JNIEnv *env, jobject thisObj, jint conn, jstring musername, jstring mpassword, jstring mtrackdata,
               jstring maccount, jstring mexpdate, jdouble amount, jstring mstreet, jstring mzip, jstring mcv, jstring mcomments, jstring mclerkid, jstring mstationid, jint ptrannum)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *username, *password, *trackdata, *account, *expdate, *street=NULL, *zip, *cv, *comments, *clerkid, *stationid;
  username=Java_to_CString(env, musername);
  password=Java_to_CString(env, mpassword);
  trackdata=Java_to_CString(env, mtrackdata);
  account=Java_to_CString(env, maccount);
  expdate=Java_to_CString(env, mexpdate);
  street=Java_to_CString(env, mstreet);
  zip=Java_to_CString(env, mzip);
  cv=Java_to_CString(env, mcv);
  comments=Java_to_CString(env, mcomments);
  clerkid=Java_to_CString(env, mclerkid);
  stationid=Java_to_CString(env, mstationid);
  lock_it(env, thisObj);
  ret=MCVE_Sale(myconn, username, password, trackdata, account, expdate, amount, street, zip, cv, comments, clerkid, stationid, ptrannum);
  unlock_it(env, thisObj);
  Free_CString(env, musername, username);
  Free_CString(env, mpassword, password);
  Free_CString(env, mtrackdata, trackdata);
  Free_CString(env, maccount, account);
  Free_CString(env, mexpdate, expdate);
  Free_CString(env, mstreet, street);
  Free_CString(env, mzip, zip);
  Free_CString(env, mcv, cv);
  Free_CString(env, mcomments, comments);
  Free_CString(env, mclerkid, clerkid);
  Free_CString(env, mstationid, stationid);
  return(ret);
}


JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1SetDropFile(JNIEnv *env, jobject thisObj, jint conn, jstring directory)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *dir;
  lock_it(env, thisObj);
  dir=Java_to_CString(env, directory);
  ret=MCVE_SetDropFile(myconn, dir);
  Free_CString(env, directory, dir);
  unlock_it(env, thisObj);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1SetIP(JNIEnv *env, jobject thisObj, jint conn, jstring host, jint port)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *hst;
  lock_it(env, thisObj);
  hst=Java_to_CString(env, host);
  ret=MCVE_SetIP(myconn, hst, port);
  Free_CString(env, host, hst);
  unlock_it(env, thisObj);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1SetSSL(JNIEnv *env, jobject thisObj, jint conn, jstring host, jint port)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *hst;
  lock_it(env, thisObj);
  hst=Java_to_CString(env, host);
  ret=MCVE_SetSSL(myconn, hst, port);
  Free_CString(env, host, hst);
  unlock_it(env, thisObj);
  return(ret);
}


JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1Settle(JNIEnv *env, jobject thisObj, jint conn, jstring musername, jstring mpassword, jstring mbatch)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *username, *password, *batch;
  username=Java_to_CString(env, musername);
  password=Java_to_CString(env, mpassword);
  batch=Java_to_CString(env, mbatch);
  lock_it(env, thisObj);
  ret=MCVE_Settle(myconn, username, password, batch);
  unlock_it(env, thisObj);
  Free_CString(env, musername, username);
  Free_CString(env, mpassword, password);
  Free_CString(env, mbatch, batch);
  return(ret);
}


JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1TransInQueue(JNIEnv *env, jobject thisObj, jint conn)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_TransInQueue(myconn);
  unlock_it(env, thisObj);
  return(ret);
}


JNIEXPORT jstring JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1TransactionAuth(JNIEnv *env, jobject thisObj, jint conn, jint identifier)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  char *auth;
  lock_it(env, thisObj);
  auth=MCVE_TransactionAuth(myconn, identifier);
  unlock_it(env, thisObj);
  return CString_to_Java(env, auth);
}


JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1TransactionBatch(JNIEnv *env, jobject thisObj, jint conn, jint identifier)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_TransactionBatch(myconn, identifier);
  unlock_it(env, thisObj);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1TransactionID(JNIEnv *env, jobject thisObj, jint conn, jint identifier)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_TransactionID(myconn, identifier);
  unlock_it(env, thisObj);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1TransactionAVS(JNIEnv *env, jobject thisObj, jint conn, jint identifier)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_TransactionAVS(myconn, identifier);
  unlock_it(env, thisObj);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1TransactionCV(JNIEnv *env, jobject thisObj, jint conn, jint identifier)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_TransactionCV(myconn, identifier);
  unlock_it(env, thisObj);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1TransactionItem(JNIEnv *env, jobject thisObj, jint conn, jint identifier)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_TransactionItem(myconn, identifier);
  unlock_it(env, thisObj);
  return(ret);
}


JNIEXPORT jstring JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1TransactionText(JNIEnv *env, jobject thisObj, jint conn, jint identifier)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  char *text;
  lock_it(env, thisObj);
  text=MCVE_TransactionText(myconn, identifier);
  unlock_it(env, thisObj);
  return CString_to_Java(env, text);
}


JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1TransactionsSent(JNIEnv *env, jobject thisObj, jint conn)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_TransactionsSent(myconn);
  unlock_it(env, thisObj);
  return(ret);
}


JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1Void(JNIEnv *env, jobject thisObj, jint conn, jstring musername, jstring mpassword, jint sid, jint ptrannum)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *username, *password;
  username=Java_to_CString(env, musername);
  password=Java_to_CString(env, mpassword);
  lock_it(env, thisObj);
  ret=MCVE_Void(myconn, username, password, sid, ptrannum);
  unlock_it(env, thisObj);
  Free_CString(env, musername, username);
  Free_CString(env, mpassword, password);
  return(ret);
}


JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1Gut(JNIEnv *env, jobject thisObj, jint conn, jstring musername, 
								jstring mpassword, jint type, jstring macct, jstring mclerkid, 
								jstring mstationid, jstring mcomments, jdouble ptrannum,
								jstring mbdate, jstring medate)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *username, *password, *clerkid, *stationid, *comments, *acct, *bdate, *edate;
  username=Java_to_CString(env, musername);
  password=Java_to_CString(env, mpassword);
  clerkid=Java_to_CString(env, mclerkid);
  stationid=Java_to_CString(env, mstationid);
  comments=Java_to_CString(env, mcomments);
  acct=Java_to_CString(env, macct);
  bdate=Java_to_CString(env, mbdate);
  edate=Java_to_CString(env, medate);
  lock_it(env, thisObj);
  ret=MCVE_Gut(myconn, username, password, type, acct, clerkid, stationid, comments, ptrannum, bdate, edate);
  unlock_it(env, thisObj);
  Free_CString(env, musername, username);
  Free_CString(env, mpassword, password);
  Free_CString(env, macct, acct);
  Free_CString(env, mclerkid, clerkid);
  Free_CString(env, mstationid, stationid);
  Free_CString(env, mcomments, comments);
  Free_CString(env, mbdate, bdate);
  Free_CString(env, medate, edate);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1Gl(JNIEnv *env, jobject thisObj, jint conn, jstring musername, jstring mpassword, 
								jint type, jstring macct, jstring mbatch, jstring mclerkid, jstring mstationid,
								jstring mcomments, jdouble ptrannum, jstring mbdate, jstring medate)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *username, *password, *clerkid, *batch, *stationid, *comments, *acct, *bdate, *edate;
  username=Java_to_CString(env, musername);
  password=Java_to_CString(env, mpassword);
  clerkid=Java_to_CString(env, mclerkid);
  stationid=Java_to_CString(env, mstationid);
  comments=Java_to_CString(env, mcomments);
  acct=Java_to_CString(env, macct);
  bdate=Java_to_CString(env, mbdate);
  edate=Java_to_CString(env, medate);
  batch=Java_to_CString(env, mbatch);
  lock_it(env, thisObj);
  ret=MCVE_Gl(myconn, username, password, type, acct, batch, clerkid, stationid, comments, ptrannum, bdate, edate);
  unlock_it(env, thisObj);
  Free_CString(env, musername, username);
  Free_CString(env, mpassword, password);
  Free_CString(env, macct, acct);
  Free_CString(env, mclerkid, clerkid);
  Free_CString(env, mstationid, stationid);
  Free_CString(env, mcomments, comments);
  Free_CString(env, mbdate, bdate);
  Free_CString(env, medate, edate);
  Free_CString(env, mbatch, batch);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1Gft(JNIEnv *env, jobject thisObj, jint conn, jstring musername, jstring mpassword, 
								jint type, jstring macct, jstring mclerkid, jstring mstationid, jstring mcomments, 
								jdouble ptrannum, jstring mbdate, jstring medate)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *username, *password, *clerkid, *stationid, *comments, *acct, *bdate, *edate;
  username=Java_to_CString(env, musername);
  password=Java_to_CString(env, mpassword);
  clerkid=Java_to_CString(env, mclerkid);
  stationid=Java_to_CString(env, mstationid);
  comments=Java_to_CString(env, mcomments);
  acct=Java_to_CString(env, macct);
  bdate=Java_to_CString(env, mbdate);
  edate=Java_to_CString(env, medate);
  lock_it(env, thisObj);
  ret=MCVE_Gft(myconn, username, password, type, acct, clerkid, stationid, comments, ptrannum, bdate, edate);
  unlock_it(env, thisObj);
  Free_CString(env, musername, username);
  Free_CString(env, mpassword, password);
  Free_CString(env, macct, acct);
  Free_CString(env, mclerkid, clerkid);
  Free_CString(env, mstationid, stationid);
  Free_CString(env, mcomments, comments);
  Free_CString(env, mbdate, bdate);
  Free_CString(env, medate, edate);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1Bt(JNIEnv *env, jobject thisObj, jint conn, jstring musername, jstring mpassword)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *username, *password;
  username=Java_to_CString(env, musername);
  password=Java_to_CString(env, mpassword);
  lock_it(env, thisObj);
  ret=MCVE_Bt(myconn, username, password);
  unlock_it(env, thisObj);
  Free_CString(env, musername, username);
  Free_CString(env, mpassword, password);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1Ub(JNIEnv *env, jobject thisObj, jint conn, jstring musername, jstring mpassword)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  char *username, *password;
  username=Java_to_CString(env, musername);
  password=Java_to_CString(env, mpassword);
  lock_it(env, thisObj);
  ret=MCVE_Ub(myconn, username, password);
  unlock_it(env, thisObj);
  Free_CString(env, musername, username);
  Free_CString(env, mpassword, password);
  return(ret);
}


JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1IsCommaDelimited(JNIEnv *env, jobject thisObj, jint conn, jint identifier)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_IsCommaDelimited(myconn, identifier);
  unlock_it(env, thisObj);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1ParseCommaDelimited(JNIEnv *env, jobject thisObj, jint conn, jint identifier)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_ParseCommaDelimited(myconn, identifier);
  unlock_it(env, thisObj);
  return(ret);
}

JNIEXPORT jstring JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1GetCommaDelimited(JNIEnv *env, jobject thisObj, jint conn, jint identifier)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  char *text;
  lock_it(env, thisObj);
  text=MCVE_GetCommaDelimited(myconn, identifier);
  unlock_it(env, thisObj);
  return CString_to_Java(env, text);
}

JNIEXPORT jstring JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1GetCell(JNIEnv *env, jobject thisObj, jint conn, jint identifier, jstring column, jint row)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  char *text;
  char *col;
  col=Java_to_CString(env, column);
  lock_it(env, thisObj);
  text=MCVE_GetCell(myconn, identifier, col, row);
  unlock_it(env, thisObj);
  Free_CString(env, column, col);
  return CString_to_Java(env, text);
}

JNIEXPORT jstring JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1GetCellByNum(JNIEnv *env, jobject thisObj, jint conn, jint identifier, jint column, jint row)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  char *text;
  lock_it(env, thisObj);
  text=MCVE_GetCellByNum(myconn, identifier, column, row);
  unlock_it(env, thisObj);
  return CString_to_Java(env, text);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1NumColumns(JNIEnv *env, jobject thisObj, jint conn, jint identifier)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_NumColumns(myconn, identifier);
  unlock_it(env, thisObj);
  return(ret);
}

JNIEXPORT jint JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1NumRows(JNIEnv *env, jobject thisObj, jint conn, jint identifier)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  int ret;
  lock_it(env, thisObj);
  ret=MCVE_NumRows(myconn, identifier);
  unlock_it(env, thisObj);
  return(ret);
}

JNIEXPORT jstring JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1GetHeader(JNIEnv *env, jobject thisObj, jint conn, jint identifier, jint column_num)
{
  MCVE_CONN *myconn=(MCVE_CONN *)conn;
  char *text;
  lock_it(env, thisObj);
  text=MCVE_GetHeader(myconn, identifier, column_num);
  unlock_it(env, thisObj);
  return CString_to_Java(env, text);
}

JNIEXPORT jstring JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1TEXT_1Code(JNIEnv *env, jobject thisObj, jint code)
{
  return CString_to_Java(env, MCVE_TEXT_Code(code));
}

JNIEXPORT jstring JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1TEXT_1AVS(JNIEnv *env, jobject thisObj, jint code)
{
  return CString_to_Java(env, MCVE_TEXT_AVS(code));
}

JNIEXPORT jstring JNICALL Java_com_mainstreetsoftworks_MONETRA_M_1TEXT_1CV(JNIEnv *env, jobject thisObj, jint code)
{
  return CString_to_Java(env, MCVE_TEXT_CV(code));
}


